using System;
using System.IO;
using System.Xml;

using XMLBench;

namespace XMLBench {
 public class MonoBench : XMLBench {
    string nsxsi="http://www.w3.org/2001/XMLSchema-instance";
    string nsenc="http://www.w3.org/2001/12/soap-encoding";
    string nssoap="http://www.w3.org/2001/12/soap-envelope";
    string nsopc="http://opcfoundation.org/webservices/OPCDA/";

    override public void ParseXML(int enlarge, int iters, int iter) {
        XmlDocument doc = new XmlDocument();

        XmlElement proot,pnode,node,node1,node2;
        StringWriter mem = new StringWriter();
        int i;

        doc = new XmlDocument();
        proot = doc.CreateElement("Envelope",nssoap);
        proot.SetAttribute("xmlns",nssoap);
        proot.SetAttribute("xmlns:xsi",nsxsi);
        proot.SetAttribute("xmlns:enc",nsenc);
        doc.AppendChild(proot);
        pnode = doc.CreateElement("Body",nssoap);
        proot.AppendChild(pnode);

        node=doc.CreateElement("WriteResponse",nsopc);
        pnode.AppendChild(node);
        pnode=node;
        node=doc.CreateElement("WriteResult",nsopc);
        node.SetAttribute("RcvTime","2002-04-29T10:16:26.6806250+02:00");
        node.SetAttribute("ReplyTime","2002-04-29T10:16:26.7806250+02:00");
        node.SetAttribute("ClientRequestHandle","WriteError");
        node.SetAttribute("RevisedLocaleID","en");
        node.SetAttribute("ServerState","running");
        pnode.AppendChild(node);
        node1=doc.CreateElement("RItemList",nsopc);
        pnode.AppendChild(node1);
        node=doc.CreateElement("Errors",nsopc);
        node.SetAttribute("ID","E_UNKNOWNITEMID");
        pnode.AppendChild(node);
        node2=doc.CreateElement("Text",nsopc);
        node.AppendChild(node2);
        node2.AppendChild(doc.CreateTextNode("The item does not exist in the server address space."));
        node=doc.CreateElement("Errors",nsopc);
        node.SetAttribute("ID","S_CLAMP");
        pnode.AppendChild(node);
        node2=doc.CreateElement("Text",nsopc);
        node.AppendChild(node2);
        node2.AppendChild(doc.CreateTextNode("The value written was accepted but the output was clamped."));

        pnode=node1;
        node=doc.CreateElement("Items",nsopc);
        node.SetAttribute("ItemPath","");
        node.SetAttribute("ItemName","WrongItemID1");
        node.SetAttribute("Timestamp","0001-01-01T00:00:00.0000000+01:00");
        node.SetAttribute("ErrorID","E_UNKNOWNITEMID");
        pnode.AppendChild(node);
        node1=doc.CreateElement("Value",nsopc);
        node.AppendChild(node1);
        node.SetAttribute("xsi:nil","true");

        node=doc.CreateElement("Items",nsopc);
        node.SetAttribute("ItemPath","");
        node.SetAttribute("ItemName","WrongItemID2");
        node.SetAttribute("Timestamp","0001-01-01T00:00:00.0000000+01:00");
        node.SetAttribute("ErrorID","E_UNKNOWNITEMID");
        pnode.AppendChild(node);
        node1=doc.CreateElement("Value",nsopc);
        node.AppendChild(node1);
        node.SetAttribute("xsi:nil","true");

        node=doc.CreateElement("Items",nsopc);
        node.SetAttribute("ItemPath","/Reals");
        node.SetAttribute("ItemName","Float1");
        node.SetAttribute("ValueType","xsd:float");
        node.SetAttribute("Timestamp","2002-04-29T11:47:18.1493750+02:00");
        pnode.AppendChild(node);
        node1=doc.CreateElement("Value",nsopc);
        node.AppendChild(node1);
        node.SetAttribute("xsi:type","xsd:float");
        node1.AppendChild(doc.CreateTextNode("10.0141414"));

        node=doc.CreateElement("Items",nsopc);
        node.SetAttribute("ItemPath","/Reals");
        node.SetAttribute("ItemName","Float2");
        node.SetAttribute("ValueType","xsd:float");
        node.SetAttribute("Timestamp","2002-04-29T11:47:18.1493750+02:00");
        node.SetAttribute("SuccessID","S_CLAMP");
        pnode.AppendChild(node);
        node1=doc.CreateElement("Value",nsopc);
        node.AppendChild(node1);
        node.SetAttribute("xsi:type","xsd:float");
        node1.AppendChild(doc.CreateTextNode("1.07"));

        for (i=0;i<enlarge;i++) {
            node=doc.CreateElement("Items",nsopc);
            node.SetAttribute("ItemPath","/Integer");
            node.SetAttribute("ItemName","IntN");
            node.SetAttribute("ValueType","xsd:int");
            node.SetAttribute("Timestamp","2002-04-29T11:47:18.1493750+02:00");
            node.SetAttribute("SuccessID","S_CLAMP");
            pnode.AppendChild(node);
            node1=doc.CreateElement("Value",nsopc);
            node.AppendChild(node1);
            node.SetAttribute("xsi:type","xsd:int");
            node1.AppendChild(doc.CreateTextNode(""+generator.Next()));
        }
        XmlTextWriter w = new XmlTextWriter(mem);
        doc.WriteTo(w);

//	if (iter==iters) Console.WriteLine(mem);
    }
 }

 public class Mono {
    public static void Main(string[] args) {
        XMLBench bench = new MonoBench();
        bench.Bench(args);
    }
 }
}
