#include <stdio.h>
#include <sys/time.h>

#include <faxpp/parser.h>

#include "tools.h"


FAXPP_Parser *parser;

void initXML(struct TestData *td) {
    parser = FAXPP_create_parser(fast_mode?NO_CHECKS_PARSE_MODE:WELL_FORMED_PARSE_MODE, FAXPP_utf8_transcoder);
    FAXPP_set_null_terminate(parser, 0);
//    FAXPP_set_null_terminate(parser, fast_mode?0:1);
//    FAXPP_set_base_uri_str(parser, "xml");
}

void releaseXML(struct TestData *td) {
  FAXPP_free_parser(parser);
}

void parseXML(struct TestData *td, unsigned long iter) {
    int i;
    int err;

    FAXPP_init_parse(parser, td->xml, td->xmllen, 1);

    err = FAXPP_next_event(parser);
    while(!err) {
	const FAXPP_Event *ev = FAXPP_get_current_event(parser);
	
//	printf("%i\n", ev->type);
	
	if (ev->type == START_ELEMENT_EVENT) {
	    for (i = 0; i < ev->attr_count; i++) {
		ev->attrs[i];
	    }
	}
	else if(ev->type == END_DOCUMENT_EVENT) {
	    break;
	}
        err = FAXPP_next_event(parser);
    }

    if (err) {
	printf("Parsing is failed with code: %s\n", FAXPP_err_to_string(err));
	exit(1);
    }
}

int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
