#include <stdio.h>
#include <sys/time.h>
#include <libxml/xmlreader.h>

#include "tools.h"

//xmlSAXHandler handler;

void initXML(struct TestData *td) {
    xmlInitParser();
//    initxmlDefaultSAXHandler(&handler,0);
}

void releaseXML(struct TestData *td) {
    xmlCleanupParser();
}

void parseXML(struct TestData *td, unsigned long iter) {
    int res;
    xmlTextReaderPtr ctx;

#ifdef DTD_VALIDATION
    ctx = xmlReaderForMemory(td->xml, td->xmllen, "xml", NULL, XML_PARSE_DTDVALID);
#else
    ctx = xmlReaderForMemory(td->xml, td->xmllen, "xml", NULL, 0);
#endif

    if (!ctx) {
	printf("Parsing is failed\n");
	exit(1);
    }
    res = xmlTextReaderRead(ctx);
    while (res == 1) {
	//printf("%u\n", xmlTextReaderNodeType(ctx));
	if (xmlTextReaderNodeType(ctx) == XML_READER_TYPE_ELEMENT) {
	    //xmlTextReaderMoveToFirstAttribute(ctx);
	    while (xmlTextReaderMoveToNextAttribute(ctx));
	    xmlTextReaderMoveToElement(ctx);
	}
	res = xmlTextReaderRead(ctx);
    }
    xmlFreeTextReader(ctx);

    if (res) {
	printf("Parsing is failed with code: %i\n", res);
	exit(1);
    }
}

int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
