#!/usr/bin/perl
use POSIX;
use XML::LibXML;
use XML::LibXML::Common;
$parser = new XML::LibXML;

sub getnum {
    use POSIX;
    my $str = shift;
    $str =~ s/^\s+//;
    $str =~ s/\s+$//;
    $! = 0;
    my($num, $unparsed) = strtod($str);
    if (($str eq '') && ($unparsed != 0) && $!) {
        return undef;
    } else {
        return $num;
    }
}

sub parse {
    ($xml, $walk) = @_;
    $doc = $parser->parse_file ($xml);
    if ($walk) {
	my $sum = 0;
	my @nodes = $doc->findnodes("//*[count(child::*)>3]/*[number(@*) or number(text())]");
	foreach $node(@nodes) {
	    $child = $node->getFirstChild();
	    if (($child)&&($child->nodeType == TEXT_NODE)) {
		my $res = getnum($child->getData());
		if (defined $res) { $sum += $res; next;}
	    }
	    
	    @attrs = $node->attributes();
	    foreach $attr(@attrs) {
		my $res = getnum($attr->value());
		if (defined $res) { $sum += $res; last;}
	    }
	}
#	print "Sum: $sum\n";
    }
    undef($doc);
}

sub filename {
    ($i) = @_;
    if (@ARGV > 1) { return $ARGV[1]; }
    else { return "../xml.tmp/$i.xml"; }
}

my $walk_tree = $ENV{'walk_tree'};

if (@ARGV > 0) {
    $iterations = $ARGV[0];
} else {
    $iterations = 0;
}

parse(filename(0), $walk_tree);
for ($i=1;$i<=$iterations;$i++) {
    parse(filename($i), $walk_tree);
}
