#! /usr/bin/python

import libxml2, sys, os


def parse(xml, walk_tree):
    doc = libxml2.parseFile(xml)
    if walk_tree:
	ctxt = doc.xpathNewContext()
	nodes = ctxt.xpathEval("//*[count(child::*)>3]/*[number(@*) or number(text())]")
#	nodes = ctxt.xpathEval("//*[(@* or text()) and (count(../child::*)>3)]")
	sum = 0.

	for node in nodes:
	    child = node.children
	    if (child is not None and child.type == "text"):
		try:
		    res = float(child.content) 
	    	    if res:
			sum += res
			continue
		except ValueError:
		    pass
		    #Exception is not actually thrown in my python, but just 0 is returned
		    #raise ValueError

	    attrs = node.get_properties()
	    for attr in attrs if attrs is not None else []:
		try:
		    res = float(attr.children.content)
		    if res:
			sum += res
		        break
		except ValueError:
		    pass
		    #Exception is not actually thrown in my python, but just 0 is returned
		    #raise ValueError

		
	ctxt.xpathFreeContext()
#	print "Sum: %f" % sum
    doc.freeDoc


try:
    walk_tree = os.environ['walk_tree']
except:
    walk_tree = None

if len(sys.argv) > 1:
    iterations = int(sys.argv[1])
else:
    iterations = 0


if len(sys.argv) > 2:
    filename = lambda i: sys.argv[2]
else:
    filename = lambda i: "../xml.tmp/" + str(i) + ".xml"

parse(filename(0), walk_tree)

for i in range(iterations):
    parse(filename(i+1), walk_tree)
