import java.io.*;
import java.util.*;
import java.text.*;
import javax.xml.parsers.DocumentBuilderFactory; 
import javax.xml.parsers.DocumentBuilder; 

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import java.lang.Float;

public class sun_dom2 extends bench {
 int walk_mode;
 DocumentBuilder parser;
 DocumentBuilderFactory factory;

 double walker_process_node(Node cur_node) {
    double res;
    Node child;
    
    child = cur_node.getFirstChild();
    if ((child!=null)&&(child.getNodeType() == Node.TEXT_NODE)) {
	try {
	    res = Float.parseFloat(child.getNodeValue());
	    if (res!=0) return res;
	} catch(Exception e) {
	}
    } 

    NamedNodeMap attrMap = cur_node.getAttributes();
    int length = attrMap.getLength();

    for (int i = 0; i < length; i++) {
	try {
	    res = Float.parseFloat(attrMap.item(i).getNodeValue());
	    if (res!=0) return res;
	} catch (Exception e) {
	}
    }

    return 0;
 }


 double walker(Node node) {
    int i = 0;
    double res = 0;
    Node cur_node;

    for (cur_node = node; cur_node!=null; cur_node = cur_node.getNextSibling()) {
	if((cur_node.getNodeType() == Node.ELEMENT_NODE)&&(++i>3)) break;
    }
    
    if (i<=3) i = 0;

    for (cur_node = node; cur_node!=null; cur_node = cur_node.getNextSibling()) {
	if (cur_node.getNodeType() == Node.ELEMENT_NODE) {
	    if (i>0) {
		res += walker_process_node(cur_node);
	    }
	    res+=walker(cur_node.getFirstChild());
	}
    }
    return res;
 }
    
 public void InitXML() {
    	factory = DocumentBuilderFactory.newInstance();
	factory.setNamespaceAware(true);
	factory.setValidating(false);

	try {
	    if (System.getenv("allow_deferring")!=null) {
		factory.setFeature("http://apache.org/xml/features/dom/defer-node-expansion", true);
	    } else {
		factory.setFeature("http://apache.org/xml/features/dom/defer-node-expansion", false);
	    }

	    if (System.getenv("walk_tree")!=null) {
		walk_mode = 1;
	    } else {
		walk_mode = 0;
	    }
	} catch (Throwable err) {
	    // ignoring missing option
	}

	try {
    	    parser = factory.newDocumentBuilder();
	}
	catch (Throwable err) {
    	    err.printStackTrace ();
	}
 }

 public void ParseXML(FileInputStream is, int iters, int iter) {
	try {
	    Document doc = parser.parse(is);
	    if (walk_mode!=0) {
		double res = walker(doc.getFirstChild());
//		System.out.println("Sum: " + res);
	    }		
	}
	catch (Exception e)
        {
    	    System.out.println(e.toString());
        }
 }
  
 static public void main(String argv[]) throws IOException {
	bench mybench = new sun_dom2();
	mybench.Bench(argv);
 }
}
