using System;
using System.IO;
using System.Xml;
using System.Xml.Schema;

using XMLBench;

namespace XMLBench {
 public class MonoBench : XMLBench {
    public XmlSchemaCollection xsc;
    override public void InitXML_Validation(string schema_file, string schema_location) {
	xsc = new XmlSchemaCollection();
	xsc.Add(schema_location, schema_file);
    }
    override public void ParseXML(Stream xml, int iters, int iter) {
        XmlTextReader reader = new XmlTextReader(xml);
	XmlDocument doc = new XmlDocument();
	doc.Load(reader);
    }
    override public void ValidateXML(Stream xml, int iters, int iter) {
/*
	Not available yet
	XmlReaderSettings settings = new XmlReaderSettings();
*/	
        XmlValidatingReader reader = new XmlValidatingReader(new XmlTextReader(xml));
	reader.Schemas.Add(xsc);
	XmlDocument doc = new XmlDocument();
	doc.Load(reader);
    }
 }
 
 public class Mono {
    public static void Main(string[] args) {
	XMLBench bench = new MonoBench();
	bench.Bench(args);
    }
 }
}
