using System;
using System.IO;
using System.Xml;
using System.Xml.Xsl;

using XMLBench;

namespace XMLBench {
 public class MonoBench : XMLBench {
//    XslCompiledTransform xslt;
    XslTransform xslt;
    XsltArgumentList arguments;

    override public void InitXML_Transformation(string xslt_file) {
//	xslt = new XslCompiledTransform();
	xslt = new XslTransform();
	xslt.Load(xslt_file);
	arguments = new XsltArgumentList();
    }
    override public void ParseXML(Stream xml, int iters, int iter) {
        XmlTextReader reader = new XmlTextReader(xml);
	XmlDocument doc = new XmlDocument();
	doc.Load(reader);
    }
    override public void TransformXML(Stream xml, int iters, int iter) {
        XmlTextReader reader = new XmlTextReader(xml);
	XmlDocument doc = new XmlDocument();
	doc.Load(reader);
	
	StringWriter sw = new StringWriter();
	xslt.Transform(doc, arguments, sw, null);
//	Console.WriteLine(sw.ToString());
    }
 }
 
 public class Mono {
    public static void Main(string[] args) {
	XMLBench bench = new MonoBench();
	bench.Bench(args);
    }
 }
}
